
void CXtalkHw::CXtalkHw(class CAsp4HwIO	* arg_0) {
	this_00 = arg_0;
}


;  S U B	R O U T	I N E 


void CXtalkHw::SetLeftEQ(short arg_0, short arg_4, short	(* const)[5] coefs) {
	int i;
	
	for (i=0; i<5; i++) {
		hwwrite(vortex->mmio, 0x24200 + i*0x24, coefs[i][0]);
		hwwrite(vortex->mmio, 0x24204 + i*0x24, coefs[i][1]);
		hwwrite(vortex->mmio, 0x24208 + i*0x24, coefs[i][2]);
		hwwrite(vortex->mmio, 0x2420c + i*0x24, coefs[i][3]);
		hwwrite(vortex->mmio, 0x24210 + i*0x24, coefs[i][4]);
	}
	hwwrite(vortex->mmio, 0x24538, arg_0 & 0xffff);
	hwwrite(vortex->mmio, 0x2453C, arg_4 & 0xffff);
}

void CXtalkHw::GetLeftEQ(short *arg_0, short *arg_4, short (* const)[5] coefs) {
	int i;
	
	for (i=0; i<5; i++) {
		coefs[i][0] = hwread(vortex->mmio, 0x24200 + i*0x24);
		coefs[i][1] = hwread(vortex->mmio, 0x24204 + i*0x24);
		coefs[i][2] = hwread(vortex->mmio, 0x24208 + i*0x24);
		coefs[i][3] = hwread(vortex->mmio, 0x2420c + i*0x24);
		coefs[i][4] = hwread(vortex->mmio, 0x24210 + i*0x24);
	}
	*arg_0 = hwread(vortex->mmio, 0x24538) & 0xffff;
	*arg_4 = hwread(vortex->mmio, 0x2453c) & 0xffff;	
}

void CXtalkHw::SetRightEQ(short,short,short (* const)[5]) {
	int i;
	
	for (i=0; i<5; i++) {
		hwwrite(vortex->mmio, 0x242b4 + i*0x24, coefs[i][0]);
		hwwrite(vortex->mmio, 0x242b8 + i*0x24, coefs[i][1]);
		hwwrite(vortex->mmio, 0x242bc + i*0x24, coefs[i][2]);
		hwwrite(vortex->mmio, 0x242c0 + i*0x24, coefs[i][3]);
		hwwrite(vortex->mmio, 0x242c4 + i*0x24, coefs[i][4]);
	}
	hwwrite(vortex->mmio, 0x24540, arg_0 & 0xffff);
	hwwrite(vortex->mmio, 0x24544, arg_4 & 0xffff);

	
arg_0		= dword	ptr  4
arg_4		= dword	ptr  8
arg_8		= dword	ptr  0Ch

		mov	eax, [esp+arg_8]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, (offset loc_242B5+3)
		lea	edi, [eax+4]

loc_69571:				; CODE XREF: CXtalkHw::SetRightEQ(short,short,short (* const)[5])+73j
		xor	ecx, ecx
		lea	edx, [esi-4]
		mov	cx, [edi-4]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [edi-2]
		push	eax
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		lea	edx, [esi+4]
		mov	cx, [edi]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	eax, eax
		lea	ecx, [esi+8]
		mov	ax, [edi+2]
		push	eax
		push	ecx
		mov	ecx, [ebx]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [edi+4]
		lea	eax, [esi+0Ch]
		push	edx
		push	eax
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 24h
		add	edi, 0Ah
		cmp	esi, offset loc_2436C
		jl	short loc_69571

		mov	ecx, [esp+0Ch+arg_0]
		and	ecx, 0FFFFh
		push	ecx
		mov	ecx, [ebx]
		push	24540h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	edx, [esp+0Ch+arg_4]
		mov	ecx, [ebx]
		and	edx, 0FFFFh
		push	edx
		push	24544h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	edi
		pop	esi
		pop	ebx
		retn	0Ch
}


; public: void __thiscall CXtalkHw::GetRightEQ(short *,short *,short (*	const)[5])
?GetRightEQ@CXtalkHw@@QAEXPAF0QAY04F@Z:
		mov	eax, [esp+0Ch]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, 242B8h
		lea	edi, [eax+4]

loc_69621:				; CODE XREF: .text:00069674j
		lea	ecx, [esi-4]
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi-4], ax
		mov	ecx, [ebx]
		push	esi
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	edx, [esi+4]
		mov	[edi-2], ax
		mov	ecx, [ebx]
		push	edx
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi], ax
		mov	ecx, [ebx]
		lea	eax, [esi+8]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	ecx, [esi+0Ch]
		mov	[edi+2], ax
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi+4], ax
		add	esi, 24h
		add	edi, 0Ah
		cmp	esi, offset loc_2436C
		jl	short loc_69621

		mov	ecx, [ebx]
		push	24540h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	edx, [esp+10h]
		push	24544h
		mov	[edx], ax
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	ecx, [esp+14h]
		pop	edi
		pop	esi
		pop	ebx
		mov	[ecx], ax
		retn	0Ch

; 
		align 10h

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::SetLeftXT(short,short,short	(* const)[5])

?SetLeftXT@CXtalkHw@@QAEXFFQAY04F@Z proc near ;	CODE XREF: CXtalkHw::ZeroState(void)+74p
					; CXtalkHw::ProgramPipe(void)+2Dp ...

arg_0		= dword	ptr  4
arg_4		= dword	ptr  8
arg_8		= dword	ptr  0Ch

		mov	eax, [esp+arg_8]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, offset loc_2436C
		lea	edi, [eax+4]

loc_696C1:				; CODE XREF: CXtalkHw::SetLeftXT(short,short,short (* const)[5])+73j
		xor	ecx, ecx
		lea	edx, [esi-4]
		mov	cx, [edi-4]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [edi-2]
		push	eax
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		lea	edx, [esi+4]
		mov	cx, [edi]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	eax, eax
		lea	ecx, [esi+8]
		mov	ax, [edi+2]
		push	eax
		push	ecx
		mov	ecx, [ebx]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [edi+4]
		lea	eax, [esi+0Ch]
		push	edx
		push	eax
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 24h
		add	edi, 0Ah
		cmp	esi, 24420h
		jl	short loc_696C1

		mov	ecx, [esp+0Ch+arg_0]
		and	ecx, 0FFFFh
		push	ecx
		mov	ecx, [ebx]
		push	offset loc_24548
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	edx, [esp+0Ch+arg_4]
		mov	ecx, [ebx]
		and	edx, 0FFFFh
		push	edx
		push	2454Ch
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	edi
		pop	esi
		pop	ebx
		retn	0Ch

?SetLeftXT@CXtalkHw@@QAEXFFQAY04F@Z endp

; 
		align 8

; public: void __thiscall CXtalkHw::GetLeftXT(short *,short *,short (* const)[5])
?GetLeftXT@CXtalkHw@@QAEXPAF0QAY04F@Z:
		mov	eax, [esp+0Ch]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, offset loc_2436C
		lea	edi, [eax+4]

loc_69771:				; CODE XREF: .text:000697C4j
		lea	ecx, [esi-4]
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi-4], ax
		mov	ecx, [ebx]
		push	esi
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	edx, [esi+4]
		mov	[edi-2], ax
		mov	ecx, [ebx]
		push	edx
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi], ax
		mov	ecx, [ebx]
		lea	eax, [esi+8]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	ecx, [esi+0Ch]
		mov	[edi+2], ax
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi+4], ax
		add	esi, 24h
		add	edi, 0Ah
		cmp	esi, 24420h
		jl	short loc_69771

		mov	ecx, [ebx]
		push	offset loc_24548
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	edx, [esp+10h]
		push	2454Ch
		mov	[edx], ax
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	ecx, [esp+14h]
		pop	edi
		pop	esi
		pop	ebx
		mov	[ecx], ax
		retn	0Ch

; 
		align 10h

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::SetRightXT(short,short,short (* const)[5])

?SetRightXT@CXtalkHw@@QAEXFFQAY04F@Z proc near ; CODE XREF: CXtalkHw::ZeroState(void)+84p
					; CXtalkHw::ProgramPipe(void)+3Dp ...

arg_0		= dword	ptr  4
arg_4		= dword	ptr  8
arg_8		= dword	ptr  0Ch

		mov	eax, [esp+arg_8]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, 24420h
		lea	edi, [eax+4]

loc_69811:				; CODE XREF: CXtalkHw::SetRightXT(short,short,short (* const)[5])+73j
		xor	ecx, ecx
		lea	edx, [esi-4]
		mov	cx, [edi-4]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [edi-2]
		push	eax
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		lea	edx, [esi+4]
		mov	cx, [edi]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	eax, eax
		lea	ecx, [esi+8]
		mov	ax, [edi+2]
		push	eax
		push	ecx
		mov	ecx, [ebx]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [edi+4]
		lea	eax, [esi+0Ch]
		push	edx
		push	eax
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 24h
		add	edi, 0Ah
		cmp	esi, offset loc_244D4
		jl	short loc_69811

		mov	ecx, [esp+0Ch+arg_0]
		and	ecx, 0FFFFh
		push	ecx
		mov	ecx, [ebx]
		push	24550h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	edx, [esp+0Ch+arg_4]
		mov	ecx, [ebx]
		and	edx, 0FFFFh
		push	edx
		push	24554h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	edi
		pop	esi
		pop	ebx
		retn	0Ch

?SetRightXT@CXtalkHw@@QAEXFFQAY04F@Z endp

; 
		align 8

; public: void __thiscall CXtalkHw::GetRightXT(short *,short *,short (*	const)[5])
?GetRightXT@CXtalkHw@@QAEXPAF0QAY04F@Z:
		mov	eax, [esp+0Ch]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, 24420h
		lea	edi, [eax+4]

loc_698C1:				; CODE XREF: .text:00069914j
		lea	ecx, [esi-4]
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi-4], ax
		mov	ecx, [ebx]
		push	esi
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	edx, [esi+4]
		mov	[edi-2], ax
		mov	ecx, [ebx]
		push	edx
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi], ax
		mov	ecx, [ebx]
		lea	eax, [esi+8]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	ecx, [esi+0Ch]
		mov	[edi+2], ax
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi+4], ax
		add	esi, 24h
		add	edi, 0Ah
		cmp	esi, offset loc_244D4
		jl	short loc_698C1

		mov	ecx, [ebx]
		push	24550h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	edx, [esp+10h]
		push	24554h
		mov	[edx], ax
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	ecx, [esp+14h]
		pop	edi
		pop	esi
		pop	ebx
		mov	[ecx], ax
		retn	0Ch

; 
		align 10h

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::SetLeftEQStates(short const	* const,short (* const)[4])

?SetLeftEQStates@CXtalkHw@@QAEXQBFQAY03F@Z proc	near
					; CODE XREF: CXtalkHw::ZeroState(void)+186p

arg_0		= dword	ptr  4
arg_4		= dword	ptr  8

		mov	eax, [esp+arg_4]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, (offset loc_24214+4)
		lea	edi, [eax+4]

loc_69961:				; CODE XREF: CXtalkHw::SetLeftEQStates(short const * const,short (* const)[4])+61j
		xor	ecx, ecx
		lea	edx, [esi-4]
		mov	cx, [edi-4]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [edi-2]
		push	eax
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		lea	edx, [esi+4]
		mov	cx, [edi]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	eax, eax
		lea	ecx, [esi+8]
		mov	ax, [edi+2]
		push	eax
		push	ecx
		mov	ecx, [ebx]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 24h
		add	edi, 8
		cmp	esi, (offset loc_242CB+1)
		jl	short loc_69961

		mov	esi, [esp+0Ch+arg_0]
		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [esi]
		push	edx
		push	offset loc_244F8
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [esi+2]
		push	eax
		push	244FCh
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		mov	cx, [esi+4]
		push	ecx
		mov	ecx, [ebx]
		push	offset loc_24500
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [esi+6]
		push	edx
		push	24504h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	edi
		pop	esi
		pop	ebx
		retn	8

?SetLeftEQStates@CXtalkHw@@QAEXQBFQAY03F@Z endp

; 
		align 10h

; public: void __thiscall CXtalkHw::GetLeftEQStates(short * const,short	(* const)[4])
?GetLeftEQStates@CXtalkHw@@QAEXQAFQAY03F@Z:
		mov	eax, [esp+8]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, 24218h
		lea	edi, [eax+4]

loc_69A21:				; CODE XREF: .text:00069A65j
		lea	ecx, [esi-4]
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi-4], ax
		mov	ecx, [ebx]
		push	esi
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	edx, [esi+4]
		mov	[edi-2], ax
		mov	ecx, [ebx]
		push	edx
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi], ax
		mov	ecx, [ebx]
		lea	eax, [esi+8]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi+2], ax
		add	esi, 24h
		add	edi, 8
		cmp	esi, 242CCh
		jl	short loc_69A21

		mov	ecx, [ebx]
		push	offset loc_244F8
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	esi, [esp+10h]
		push	244FCh
		mov	[esi], ax
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+2], ax
		mov	ecx, [ebx]
		push	offset loc_24500
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+4], ax
		mov	ecx, [ebx]
		push	24504h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+6], ax
		pop	edi
		pop	esi
		pop	ebx
		retn	8


;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::SetRightEQStates(short const * const,short (* const)[4])

?SetRightEQStates@CXtalkHw@@QAEXQBFQAY03F@Z proc near
					; CODE XREF: CXtalkHw::ZeroState(void)+197p

arg_0		= dword	ptr  4
arg_4		= dword	ptr  8

		mov	eax, [esp+arg_4]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, (offset loc_242CB+1)
		lea	edi, [eax+4]

loc_69AC1:				; CODE XREF: CXtalkHw::SetRightEQStates(short const * const,short (* const)[4])+61j
		xor	ecx, ecx
		lea	edx, [esi-4]
		mov	cx, [edi-4]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [edi-2]
		push	eax
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		lea	edx, [esi+4]
		mov	cx, [edi]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	eax, eax
		lea	ecx, [esi+8]
		mov	ax, [edi+2]
		push	eax
		push	ecx
		mov	ecx, [ebx]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 24h
		add	edi, 8
		cmp	esi, offset off_24380
		jl	short loc_69AC1

		mov	esi, [esp+0Ch+arg_0]
		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [esi]
		push	edx
		push	24508h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [esi+2]
		push	eax
		push	offset loc_2450C
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		mov	cx, [esi+4]
		push	ecx
		mov	ecx, [ebx]
		push	24510h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [esi+6]
		push	edx
		push	24514h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	edi
		pop	esi
		pop	ebx
		retn	8

?SetRightEQStates@CXtalkHw@@QAEXQBFQAY03F@Z endp

; 
		align 10h

; public: void __thiscall CXtalkHw::GetRightEQStates(short * const,short (* const)[4])
?GetRightEQStates@CXtalkHw@@QAEXQAFQAY03F@Z:
		mov	eax, [esp+8]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, 242CCh
		lea	edi, [eax+4]

loc_69B81:				; CODE XREF: .text:00069BC5j
		lea	ecx, [esi-4]
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi-4], ax
		mov	ecx, [ebx]
		push	esi
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	edx, [esi+4]
		mov	[edi-2], ax
		mov	ecx, [ebx]
		push	edx
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi], ax
		mov	ecx, [ebx]
		lea	eax, [esi+8]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi+2], ax
		add	esi, 24h
		add	edi, 8
		cmp	esi, offset off_24380
		jl	short loc_69B81

		mov	ecx, [ebx]
		push	24508h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	esi, [esp+10h]
		push	offset loc_2450C
		mov	[esi], ax
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+2], ax
		mov	ecx, [ebx]
		push	24510h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+4], ax
		mov	ecx, [ebx]
		push	24514h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+6], ax
		pop	edi
		pop	esi
		pop	ebx
		retn	8


;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::SetLeftXTStates(short const	* const,short (* const)[4])

?SetLeftXTStates@CXtalkHw@@QAEXQBFQAY03F@Z proc	near
					; CODE XREF: CXtalkHw::ZeroState(void)+1A8p

arg_0		= dword	ptr  4
arg_4		= dword	ptr  8

		mov	eax, [esp+arg_4]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, offset off_24380
		lea	edi, [eax+4]

loc_69C21:				; CODE XREF: CXtalkHw::SetLeftXTStates(short const * const,short (* const)[4])+61j
		xor	ecx, ecx
		lea	edx, [esi-4]
		mov	cx, [edi-4]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [edi-2]
		push	eax
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		lea	edx, [esi+4]
		mov	cx, [edi]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	eax, eax
		lea	ecx, [esi+8]
		mov	ax, [edi+2]
		push	eax
		push	ecx
		mov	ecx, [ebx]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 24h
		add	edi, 8
		cmp	esi, 24434h
		jl	short loc_69C21

		mov	esi, [esp+0Ch+arg_0]
		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [esi]
		push	edx
		push	offset loc_24518
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [esi+2]
		push	eax
		push	2451Ch
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		mov	cx, [esi+4]
		push	ecx
		mov	ecx, [ebx]
		push	24520h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [esi+6]
		push	edx
		push	24524h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	edi
		pop	esi
		pop	ebx
		retn	8

?SetLeftXTStates@CXtalkHw@@QAEXQBFQAY03F@Z endp

; 
		align 10h

; public: void __thiscall CXtalkHw::GetLeftXTStates(short * const,short	(* const)[4])
?GetLeftXTStates@CXtalkHw@@QAEXQAFQAY03F@Z:
		mov	eax, [esp+8]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, offset off_24380
		lea	edi, [eax+4]

loc_69CE1:				; CODE XREF: .text:00069D25j
		lea	ecx, [esi-4]
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi-4], ax
		mov	ecx, [ebx]
		push	esi
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	edx, [esi+4]
		mov	[edi-2], ax
		mov	ecx, [ebx]
		push	edx
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi], ax
		mov	ecx, [ebx]
		lea	eax, [esi+8]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi+2], ax
		add	esi, 24h
		add	edi, 8
		cmp	esi, 24434h
		jl	short loc_69CE1

		mov	ecx, [ebx]
		push	offset loc_24518
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	esi, [esp+10h]
		push	2451Ch
		mov	[esi], ax
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+2], ax
		mov	ecx, [ebx]
		push	24520h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+4], ax
		mov	ecx, [ebx]
		push	24524h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+6], ax
		pop	edi
		pop	esi
		pop	ebx
		retn	8


;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::SetRightXTStates(short const * const,short (* const)[4])

?SetRightXTStates@CXtalkHw@@QAEXQBFQAY03F@Z proc near
					; CODE XREF: CXtalkHw::ZeroState(void)+1B9p

arg_0		= dword	ptr  4
arg_4		= dword	ptr  8

		mov	eax, [esp+arg_4]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, 24434h
		lea	edi, [eax+4]

loc_69D81:				; CODE XREF: CXtalkHw::SetRightXTStates(short const * const,short (* const)[4])+61j
		xor	ecx, ecx
		lea	edx, [esi-4]
		mov	cx, [edi-4]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [edi-2]
		push	eax
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		lea	edx, [esi+4]
		mov	cx, [edi]
		push	ecx
		mov	ecx, [ebx]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	eax, eax
		lea	ecx, [esi+8]
		mov	ax, [edi+2]
		push	eax
		push	ecx
		mov	ecx, [ebx]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 24h
		add	edi, 8
		cmp	esi, offset loc_244E8
		jl	short loc_69D81

		mov	esi, [esp+0Ch+arg_0]
		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [esi]
		push	edx
		push	offset loc_24528
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [esi+2]
		push	eax
		push	2452Ch
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		xor	ecx, ecx
		mov	cx, [esi+4]
		push	ecx
		mov	ecx, [ebx]
		push	24530h
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [ebx]
		xor	edx, edx
		mov	dx, [esi+6]
		push	edx
		push	offset loc_24534
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	edi
		pop	esi
		pop	ebx
		retn	8

?SetRightXTStates@CXtalkHw@@QAEXQBFQAY03F@Z endp

; 
		align 10h

; public: void __thiscall CXtalkHw::GetRightXTStates(short * const,short (* const)[4])
?GetRightXTStates@CXtalkHw@@QAEXQAFQAY03F@Z:
		mov	eax, [esp+8]
		push	ebx
		push	esi
		push	edi
		mov	ebx, ecx
		mov	esi, 24434h
		lea	edi, [eax+4]

loc_69E41:				; CODE XREF: .text:00069E85j
		lea	ecx, [esi-4]
		push	ecx
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi-4], ax
		mov	ecx, [ebx]
		push	esi
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		lea	edx, [esi+4]
		mov	[edi-2], ax
		mov	ecx, [ebx]
		push	edx
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi], ax
		mov	ecx, [ebx]
		lea	eax, [esi+8]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi+2], ax
		add	esi, 24h
		add	edi, 8
		cmp	esi, offset loc_244E8
		jl	short loc_69E41

		mov	ecx, [ebx]
		push	offset loc_24528
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	esi, [esp+10h]
		push	2452Ch
		mov	[esi], ax
		mov	ecx, [ebx]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+2], ax
		mov	ecx, [ebx]
		push	24530h
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+4], ax
		mov	ecx, [ebx]
		push	offset loc_24534
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esi+6], ax
		pop	edi
		pop	esi
		pop	ebx
		retn	8


;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::SetGains(short const *)

?SetGains@CXtalkHw@@QAEXPBF@Z proc near	; CODE XREF: CVort3DRend::Initialize(ushort)+5Bp

arg_0		= dword	ptr  10h

		push	ebx
		push	esi
		push	edi
		mov	edi, [esp+arg_0]
		mov	ebx, ecx
		mov	esi, 244D0h

loc_69EDE:				; CODE XREF: CXtalkHw::SetGains(short const *)+28j
		mov	ecx, [ebx]
		xor	eax, eax
		mov	ax, [edi]
		push	eax
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 4
		add	edi, 2
		cmp	esi, offset loc_244F8
		jl	short loc_69EDE

		pop	edi
		pop	esi
		pop	ebx
		retn	4

?SetGains@CXtalkHw@@QAEXPBF@Z endp

; 

; public: void __thiscall CXtalkHw::GetGains(short *)
?GetGains@CXtalkHw@@QAEXPAF@Z:
		push	ebx
		push	esi
		push	edi
		mov	edi, [esp+10h]
		mov	ebx, ecx
		mov	esi, 244D0h

loc_69F0E:				; CODE XREF: .text:00069F25j
		mov	ecx, [ebx]
		push	esi
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[edi], ax
		add	esi, 4
		add	edi, 2
		cmp	esi, offset loc_244F8
		jl	short loc_69F0E

		pop	edi
		pop	esi
		pop	ebx
		retn	4

; 
		align 4

; public: void __thiscall CXtalkHw::SetDelay(unsigned short,unsigned short)
?SetDelay@CXtalkHw@@QAEXGG@Z:
		push	ecx
		mov	dword ptr [esp+0], 0
		mov	eax, [esp+0]
		and	eax, 1FFFFFFFh
		or	eax, 0A0000000h
		mov	[esp+0], eax
		mov	edx, [esp+0Ch]
		and	edx, 1Fh
		shl	edx, 8
		mov	eax, [esp+0]
		and	ah, 0E0h
		or	edx, eax
		mov	[esp+0], edx
		mov	edx, [esp+8]
		and	edx, 1Fh
		shl	edx, 0Dh
		mov	eax, [esp+0]
		and	eax, 0FFFC1FFFh
		or	edx, eax
		mov	[esp+0], edx
		mov	eax, [esp+0]
		mov	ecx, [ecx]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	ecx
		retn	8

; 

; public: void __thiscall CXtalkHw::GetDelay(unsigned short *,unsigned short *)
?GetDelay@CXtalkHw@@QAEXPAG0@Z:
		push	ecx
		mov	ecx, [ecx]
		push	offset loc_24660
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esp+0], eax
		mov	eax, [esp+0]
		mov	ecx, [esp+0Ch]
		shr	eax, 8
		and	eax, 1Fh
		mov	[ecx], ax
		mov	edx, [esp+0]
		mov	eax, [esp+8]
		shr	edx, 0Dh
		and	edx, 1Fh
		mov	[eax], dx
		pop	ecx
		retn	8

; 
		align 10h

; public: void __thiscall CXtalkHw::SetLeftDline(long const *)
?SetLeftDline@CXtalkHw@@QAEXPBJ@Z:
		push	ebx
		push	ebp
		push	esi
		mov	esi, [esp+10h]
		mov	ebx, 24000h
		mov	ebp, 24080h
		push	edi
		sub	ebx, esi
		mov	edi, ecx
		sub	ebp, esi
		mov	dword ptr [esp+14h], 20h

loc_69FF0:				; CODE XREF: .text:0006A020j
		mov	eax, [esi]
		lea	ecx, [ebx+esi]
		and	eax, 0FFFFh
		push	eax
		push	ecx
		mov	ecx, [edi]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	edx, [esi]
		mov	ecx, [edi]
		shr	edx, 10h
		lea	eax, [esi+ebp]
		push	edx
		push	eax
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	eax, [esp+14h]
		add	esi, 4
		dec	eax
		mov	[esp+14h], eax
		jnz	short loc_69FF0

		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		retn	4

; 
		align 8

; public: void __thiscall CXtalkHw::GetLeftDline(long *)
?GetLeftDline@CXtalkHw@@QAEXPAJ@Z:
		push	ebx
		push	ebp
		mov	ebp, [esp+0Ch]
		push	esi
		push	edi
		mov	edi, ecx
		mov	esi, 24080h

loc_6A03F:				; CODE XREF: .text:0006A069j
		mov	ecx, [edi]
		lea	eax, [esi-80h]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	ecx, [edi]
		push	esi
		mov	ebx, eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		shl	eax, 10h
		add	eax, ebx
		mov	[esi+ebp-24080h], eax
		add	esi, 4
		cmp	esi, 24100h
		jl	short loc_6A03F

		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		retn	4

; 
		align 10h

; public: void __thiscall CXtalkHw::SetRightDline(long const *)
?SetRightDline@CXtalkHw@@QAEXPBJ@Z:
		push	ebx
		push	ebp
		push	esi
		mov	esi, [esp+10h]
		mov	ebx, 24100h
		mov	ebp, 24180h
		push	edi
		sub	ebx, esi
		mov	edi, ecx
		sub	ebp, esi
		mov	dword ptr [esp+14h], 20h

loc_6A0A0:				; CODE XREF: .text:0006A0D0j
		mov	eax, [esi]
		lea	ecx, [ebx+esi]
		and	eax, 0FFFFh
		push	eax
		push	ecx
		mov	ecx, [edi]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	edx, [esi]
		mov	ecx, [edi]
		shr	edx, 10h
		lea	eax, [esi+ebp]
		push	edx
		push	eax
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	eax, [esp+14h]
		add	esi, 4
		dec	eax
		mov	[esp+14h], eax
		jnz	short loc_6A0A0

		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		retn	4

; 
		align 8

; public: void __thiscall CXtalkHw::GetRightDline(long *)
?GetRightDline@CXtalkHw@@QAEXPAJ@Z:
		push	ebx
		push	ebp
		mov	ebp, [esp+0Ch]
		push	esi
		push	edi
		mov	edi, ecx
		mov	esi, 24180h

loc_6A0EF:				; CODE XREF: .text:0006A119j
		mov	ecx, [edi]
		lea	eax, [esi-80h]
		push	eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	ecx, [edi]
		push	esi
		mov	ebx, eax
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		shl	eax, 10h
		add	eax, ebx
		mov	[esi+ebp-24180h], eax
		add	esi, 4
		cmp	esi, 24200h
		jl	short loc_6A0EF

		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		retn	4

; 
		align 10h

; public: void __thiscall CXtalkHw::SetControlReg(unsigned long)
?SetControlReg@CXtalkHw@@QAEXK@Z:
		mov	eax, [esp+4]
		mov	ecx, [ecx]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		retn	4

; 
		align 10h

; public: void __thiscall CXtalkHw::GetControlReg(unsigned long	*)
?GetControlReg@CXtalkHw@@QAEXPAK@Z:
		mov	ecx, [ecx]
		push	offset loc_24660
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	ecx, [esp+4]
		mov	[ecx], eax
		retn	4

; 
		align 10h

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::SetSampleRate(int)

?SetSampleRate@CXtalkHw@@QAEXH@Z proc near ; CODE XREF:	CVort3DRend::Initialize(ushort)+8Dp

arg_0		= dword	ptr  0Ch

		push	ecx
		push	esi
		mov	esi, ecx
		push	offset loc_24660
		mov	ecx, [esi]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esp+4], eax
		mov	eax, [esp+4]
		and	eax, 1FFFFFFFh
		or	eax, 0C0000000h
		mov	[esp+4], eax
		mov	ecx, [esp+4]
		mov	edx, [esp+arg_0]
		and	cl, 7
		and	edx, 1Fh
		shl	edx, 3
		or	ecx, edx
		mov	[esp+4], ecx
		mov	eax, [esp+4]
		mov	ecx, [esi]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	esi
		pop	ecx
		retn	4

?SetSampleRate@CXtalkHw@@QAEXH@Z endp

; 
		align 10h

; public: void __thiscall CXtalkHw::GetSampleRate(int *)
?GetSampleRate@CXtalkHw@@QAEXPAH@Z:
		push	ecx
		mov	ecx, [ecx]
		push	offset loc_24660
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esp+0], eax
		mov	eax, [esp+0]
		mov	ecx, [esp+8]
		shr	eax, 3
		and	eax, 1Fh
		mov	[ecx], eax
		pop	ecx
		retn	4

; 
		align 10h

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::Enable(void)

?Enable@CXtalkHw@@QAEXXZ proc near	; CODE XREF: CVort3DRend::Initialize(ushort)+95p
		push	ecx
		push	esi
		mov	esi, ecx
		push	offset loc_24660
		mov	ecx, [esi]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esp+4], eax
		mov	eax, [esp+4]
		and	eax, 1FFFFFFFh
		or	eax, 0C0000000h
		mov	[esp+4], eax
		mov	ecx, [esp+4]
		or	ecx, 1
		mov	[esp+4], ecx
		mov	eax, [esp+4]
		mov	ecx, [esi]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	esi
		pop	ecx
		retn

?Enable@CXtalkHw@@QAEXXZ endp

; 
		align 10h

; public: void __thiscall CXtalkHw::Disable(void)
?Disable@CXtalkHw@@QAEXXZ:
		push	ecx
		push	esi
		mov	esi, ecx
		push	offset loc_24660
		mov	ecx, [esi]
		call	?ReadDWORD@CAsp4HwIO@@QAEKK@Z ;	CAsp4HwIO::ReadDWORD(ulong)

		mov	[esp+4], eax
		mov	eax, [esp+4]
		and	eax, 1FFFFFFFh
		or	eax, 0C0000000h
		mov	[esp+4], eax
		mov	ecx, [esp+4]
		and	ecx, 0FFFFFFFEh
		mov	[esp+4], ecx
		mov	eax, [esp+4]
		mov	ecx, [esi]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	esi
		pop	ecx
		retn

; 
		align 10h

; public: void __thiscall CXtalkHw::ZeroIO(void)
?ZeroIO@CXtalkHw@@QAEXXZ:
		push	esi
		push	edi
		mov	edi, ecx
		mov	esi, 24600h

loc_6A2A9:				; CODE XREF: .text:0006A2BCj
		mov	ecx, [edi]
		push	0
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 4
		cmp	esi, 24650h
		jl	short loc_6A2A9

		mov	esi, 24650h

loc_6A2C3:				; CODE XREF: .text:0006A2D6j
		mov	ecx, [edi]
		push	0
		push	esi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	esi, 4
		cmp	esi, offset loc_24660
		jl	short loc_6A2C3

		pop	edi
		pop	esi
		retn

; 
		align 8

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::ZeroState(void)

?ZeroState@CXtalkHw@@QAEXXZ proc near	; CODE XREF: CResource::Initialize(CAsp4Core *,CAsp4HwIO *)+262p
		push	ecx
		push	ebx
		push	ebp
		push	esi
		mov	esi, ecx
		push	edi
		push	0
		mov	ecx, [esi]
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	edi, 24600h

loc_6A2FA:				; CODE XREF: CXtalkHw::ZeroState(void)+2Dj
		mov	ecx, [esi]
		push	0
		push	edi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	edi, 4
		cmp	edi, 24650h
		jl	short loc_6A2FA

		mov	edi, 24650h

loc_6A314:				; CODE XREF: CXtalkHw::ZeroState(void)+47j
		mov	ecx, [esi]
		push	0
		push	edi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	edi, 4
		cmp	edi, offset loc_24660
		jl	short loc_6A314

		push	offset ?asXtalkCoefsZeros@@3PAY04FA ; short (* asXtalkCoefsZeros)[5]
		push	0
		push	0
		mov	ecx, esi
		call	?SetLeftEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftEQ(short,short,short (* const)[5])

		push	offset ?asXtalkCoefsZeros@@3PAY04FA ; short (* asXtalkCoefsZeros)[5]
		push	0
		push	0
		mov	ecx, esi
		call	?SetRightEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightEQ(short,short,short (* const)[5])

		push	offset ?asXtalkCoefsZeros@@3PAY04FA ; short (* asXtalkCoefsZeros)[5]
		push	0
		push	0
		mov	ecx, esi
		call	?SetLeftXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftXT(short,short,short (* const)[5])

		push	offset ?asXtalkCoefsZeros@@3PAY04FA ; short (* asXtalkCoefsZeros)[5]
		push	0
		push	0
		mov	ecx, esi
		call	?SetRightXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightXT(short,short,short (* const)[5])

		mov	edi, 244D0h
		mov	ebx, offset ?asXtalkGainsZeros@@3QBFB ;	short const * const asXtalkGainsZeros

loc_6A373:				; CODE XREF: CXtalkHw::ZeroState(void)+ADj
		mov	ecx, [esi]
		xor	eax, eax
		mov	ax, [ebx]
		push	eax
		push	edi
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	edi, 4
		add	ebx, 2
		cmp	edi, offset loc_244F8
		jl	short loc_6A373

		mov	dword ptr [esp+10h], 0
		mov	ecx, [esp+10h]
		and	ecx, 1FFFFFFFh
		or	ecx, 0A0000000h
		mov	[esp+10h], ecx
		mov	edx, [esp+10h]
		and	dh, 0E0h
		mov	[esp+10h], edx
		mov	eax, [esp+10h]
		and	eax, 0FFFC1FFFh
		mov	[esp+10h], eax
		mov	eax, [esp+10h]
		mov	ecx, [esi]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	edi, offset ?alXtalkDlineZeros@@3QBJB ;	long const * const alXtalkDlineZeros
		mov	ebx, 24000h
		mov	ebp, 24080h
		sub	ebx, edi
		sub	ebp, edi

loc_6A3E7:				; CODE XREF: CXtalkHw::ZeroState(void)+135j
		mov	ecx, [edi]
		lea	edx, [ebx+edi]
		and	ecx, 0FFFFh
		push	ecx
		mov	ecx, [esi]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	eax, [edi]
		lea	ecx, [edi+ebp]
		shr	eax, 10h
		push	eax
		push	ecx
		mov	ecx, [esi]
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	edi, 4
		cmp	edi, offset ?asXtalkGainsTest@@3QBFB ; short const * const asXtalkGainsTest
		jl	short loc_6A3E7

		mov	edi, offset ?alXtalkDlineZeros@@3QBJB ;	long const * const alXtalkDlineZeros
		mov	ebx, 24100h
		mov	ebp, (offset loc_2417F+1)
		sub	ebx, edi
		sub	ebp, edi

loc_6A42A:				; CODE XREF: CXtalkHw::ZeroState(void)+178j
		mov	edx, [edi]
		mov	ecx, [esi]
		and	edx, 0FFFFh
		lea	eax, [ebx+edi]
		push	edx
		push	eax
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		mov	ecx, [edi]
		lea	edx, [edi+ebp]
		shr	ecx, 10h
		push	ecx
		mov	ecx, [esi]
		push	edx
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		add	edi, 4
		cmp	edi, offset ?asXtalkGainsTest@@3QBFB ; short const * const asXtalkGainsTest
		jl	short loc_6A42A

		push	offset ?asXtalkOutStateZeros@@3PAY03FA ; short (* asXtalkOutStateZeros)[4]
		push	offset ?asXtalkInStateZeros@@3QBFB ; short const * const asXtalkInStateZeros
		mov	ecx, esi
		call	?SetLeftEQStates@CXtalkHw@@QAEXQBFQAY03F@Z ; CXtalkHw::SetLeftEQStates(short const * const,short (* const)[4])

		push	offset ?asXtalkOutStateZeros@@3PAY03FA ; short (* asXtalkOutStateZeros)[4]
		push	offset ?asXtalkInStateZeros@@3QBFB ; short const * const asXtalkInStateZeros
		mov	ecx, esi
		call	?SetRightEQStates@CXtalkHw@@QAEXQBFQAY03F@Z ; CXtalkHw::SetRightEQStates(short const * const,short (* const)[4])

		push	offset ?asXtalkOutStateZeros@@3PAY03FA ; short (* asXtalkOutStateZeros)[4]
		push	offset ?asXtalkInStateZeros@@3QBFB ; short const * const asXtalkInStateZeros
		mov	ecx, esi
		call	?SetLeftXTStates@CXtalkHw@@QAEXQBFQAY03F@Z ; CXtalkHw::SetLeftXTStates(short const * const,short (* const)[4])

		push	offset ?asXtalkOutStateZeros@@3PAY03FA ; short (* asXtalkOutStateZeros)[4]
		push	offset ?asXtalkInStateZeros@@3QBFB ; short const * const asXtalkInStateZeros
		mov	ecx, esi
		call	?SetRightXTStates@CXtalkHw@@QAEXQBFQAY03F@Z ; CXtalkHw::SetRightXTStates(short const * const,short (* const)[4])

		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		pop	ecx
		retn

?ZeroState@CXtalkHw@@QAEXXZ endp

; 
		align 10h

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::ProgramPipe(void)

?ProgramPipe@CXtalkHw@@QAEXXZ proc near	; CODE XREF: CVort3DRend::Initialize(ushort)+6Cp
					; .text:00066C25p
		push	ecx
		push	esi
		push	offset ?asXtalkCoefsPipe@@3PAY04FA ; short (* asXtalkCoefsPipe)[5]
		push	1
		mov	esi, ecx
		push	0
		call	?SetLeftEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftEQ(short,short,short (* const)[5])

		push	offset ?asXtalkCoefsPipe@@3PAY04FA ; short (* asXtalkCoefsPipe)[5]
		push	1
		push	0
		mov	ecx, esi
		call	?SetRightEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightEQ(short,short,short (* const)[5])

		push	offset ?asXtalkCoefsZeros@@3PAY04FA ; short (* asXtalkCoefsZeros)[5]
		push	0
		push	0
		mov	ecx, esi
		call	?SetLeftXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftXT(short,short,short (* const)[5])

		push	offset ?asXtalkCoefsZeros@@3PAY04FA ; short (* asXtalkCoefsZeros)[5]
		push	0
		push	0
		mov	ecx, esi
		call	?SetRightXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightXT(short,short,short (* const)[5])

		mov	dword ptr [esp+4], 0
		mov	eax, [esp+4]
		and	eax, 1FFFFFFFh
		or	eax, 0A0000000h
		mov	[esp+4], eax
		mov	ecx, [esp+4]
		and	ch, 0E0h
		mov	[esp+4], ecx
		mov	edx, [esp+4]
		and	edx, 0FFFC1FFFh
		mov	[esp+4], edx
		mov	eax, [esp+4]
		mov	ecx, [esi]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	esi
		pop	ecx
		retn

?ProgramPipe@CXtalkHw@@QAEXXZ endp

; 
		align 8

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::ProgramXtalkWide(void)

?ProgramXtalkWide@CXtalkHw@@QAEXXZ proc	near
					; CODE XREF: CVort3DRend::Initialize(ushort)+83p
					; .text:00066C42p

var_C		= dword	ptr -0Ch
var_8		= dword	ptr -8
var_4		= dword	ptr -4

		sub	esp, 0Ch
		mov	ax, ds:?sXtalkWideShiftLeftEq@@3FB ; short const sXtalkWideShiftLeftEq
		push	esi
		mov	esi, ecx
		push	offset ?asXtalkWideCoefsLeftEq@@3PAY04FA ; short (* asXtalkWideCoefsLeftEq)[5]
		mov	cx, ds:?sXtalkWideKLeftEq@@3FB ; short const sXtalkWideKLeftEq
		push	eax
		push	ecx
		mov	ecx, esi
		call	?SetLeftEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftEQ(short,short,short (* const)[5])

		mov	dx, ds:?sXtalkWideShiftRightEq@@3FB ; short const sXtalkWideShiftRightEq
		mov	ax, ds:?sXtalkWideKRightEq@@3FB	; short	const sXtalkWideKRightEq
		push	offset ?asXtalkWideCoefsRightEq@@3PAY04FA ; short (* asXtalkWideCoefsRightEq)[5]
		push	edx
		push	eax
		mov	ecx, esi
		call	?SetRightEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightEQ(short,short,short (* const)[5])

		mov	cx, ds:?sXtalkWideShiftLeftXt@@3FB ; short const sXtalkWideShiftLeftXt
		mov	dx, ds:?sXtalkWideKLeftXt@@3FB ; short const sXtalkWideKLeftXt
		push	offset ?asXtalkWideCoefsLeftXt@@3PAY04FA ; "U{["
		push	ecx
		push	edx
		mov	ecx, esi
		call	?SetLeftXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftXT(short,short,short (* const)[5])

		mov	ax, ds:?sXtalkWideShiftRightXt@@3FB ; short const sXtalkWideShiftRightXt
		mov	cx, ds:?sXtalkWideKRightXt@@3FB	; short	const sXtalkWideKRightXt
		push	offset ?asXtalkWideCoefsRightXt@@3PAY04FA ; "U{["
		push	eax
		push	ecx
		mov	ecx, esi
		call	?SetRightXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightXT(short,short,short (* const)[5])

		mov	dx, ds:?wXtalkWideRightDelay@@3GB ; ushort const wXtalkWideRightDelay
		mov	ax, ds:?wXtalkWideLeftDelay@@3GB ; ushort const	wXtalkWideLeftDelay
		mov	word ptr [esp+10h+var_8], dx
		mov	word ptr [esp+10h+var_4], ax
		mov	[esp+10h+var_C], 0
		mov	ecx, [esp+10h+var_C]
		and	ecx, 1FFFFFFFh
		or	ecx, 0A0000000h
		mov	[esp+10h+var_C], ecx
		mov	edx, [esp+10h+var_8]
		and	edx, 1Fh
		shl	edx, 8
		mov	eax, [esp+10h+var_C]
		and	ah, 0E0h
		or	edx, eax
		mov	[esp+10h+var_C], edx
		mov	ecx, [esp+10h+var_4]
		and	ecx, 1Fh
		shl	ecx, 0Dh
		mov	edx, [esp+10h+var_C]
		and	edx, 0FFFC1FFFh
		or	ecx, edx
		mov	[esp+10h+var_C], ecx
		mov	eax, [esp+10h+var_C]
		mov	ecx, [esi]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	esi
		add	esp, 0Ch
		retn

?ProgramXtalkWide@CXtalkHw@@QAEXXZ endp

; 
		align 4

;  S U B	R O U T	I N E 


; public: void __thiscall CXtalkHw::ProgramXtalkNarrow(void)

?ProgramXtalkNarrow@CXtalkHw@@QAEXXZ proc near
					; CODE XREF: CVort3DRend::Initialize(ushort)+7Cp
					; .text:00066C38p

var_C		= dword	ptr -0Ch
var_8		= dword	ptr -8
var_4		= dword	ptr -4

		sub	esp, 0Ch
		mov	ax, ds:?sXtalkNarrowShiftLeftEq@@3FB ; short const sXtalkNarrowShiftLeftEq
		push	esi
		mov	esi, ecx
		push	offset ?asXtalkNarrowCoefsLeftEq@@3PAY04FA ; short (* asXtalkNarrowCoefsLeftEq)[5]
		mov	cx, ds:?sXtalkNarrowKLeftEq@@3FB ; short const sXtalkNarrowKLeftEq
		push	eax
		push	ecx
		mov	ecx, esi
		call	?SetLeftEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftEQ(short,short,short (* const)[5])

		mov	dx, ds:?sXtalkNarrowShiftRightEq@@3FB ;	short const sXtalkNarrowShiftRightEq
		mov	ax, ds:?sXtalkNarrowKRightEq@@3FB ; short const	sXtalkNarrowKRightEq
		push	offset ?asXtalkNarrowCoefsRightEq@@3PAY04FA ; short (* asXtalkNarrowCoefsRightEq)[5]
		push	edx
		push	eax
		mov	ecx, esi
		call	?SetRightEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightEQ(short,short,short (* const)[5])

		mov	cx, ds:?sXtalkNarrowShiftLeftXt@@3FB ; short const sXtalkNarrowShiftLeftXt
		mov	dx, ds:?sXtalkNarrowKLeftXt@@3FB ; short const sXtalkNarrowKLeftXt
		push	offset ?asXtalkNarrowCoefsLeftXt@@3PAY04FA ; short (* asXtalkNarrowCoefsLeftXt)[5]
		push	ecx
		push	edx
		mov	ecx, esi
		call	?SetLeftXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftXT(short,short,short (* const)[5])

		mov	ax, ds:?sXtalkNarrowShiftRightXt@@3FB ;	short const sXtalkNarrowShiftRightXt
		mov	cx, ds:?sXtalkNarrowKRightXt@@3FB ; short const	sXtalkNarrowKRightXt
		push	offset ?asXtalkNarrowCoefsRightXt@@3PAY04FA ; short (* asXtalkNarrowCoefsRightXt)[5]
		push	eax
		push	ecx
		mov	ecx, esi
		call	?SetRightXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightXT(short,short,short (* const)[5])

		mov	dx, ds:?wXtalkNarrowRightDelay@@3GB ; ushort const wXtalkNarrowRightDelay
		mov	ax, ds:?wXtalkNarrowLeftDelay@@3GB ; ushort const wXtalkNarrowLeftDelay
		mov	word ptr [esp+10h+var_8], dx
		mov	word ptr [esp+10h+var_4], ax
		mov	[esp+10h+var_C], 0
		mov	ecx, [esp+10h+var_C]
		and	ecx, 1FFFFFFFh
		or	ecx, 0A0000000h
		mov	[esp+10h+var_C], ecx
		mov	edx, [esp+10h+var_8]
		and	edx, 1Fh
		shl	edx, 8
		mov	eax, [esp+10h+var_C]
		and	ah, 0E0h
		or	edx, eax
		mov	[esp+10h+var_C], edx
		mov	ecx, [esp+10h+var_4]
		and	ecx, 1Fh
		shl	ecx, 0Dh
		mov	edx, [esp+10h+var_C]
		and	edx, 0FFFC1FFFh
		or	ecx, edx
		mov	[esp+10h+var_C], ecx
		mov	eax, [esp+10h+var_C]
		mov	ecx, [esi]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	esi
		add	esp, 0Ch
		retn

?ProgramXtalkNarrow@CXtalkHw@@QAEXXZ endp

; 
		align 4

; public: void __thiscall CXtalkHw::ProgramDiamondXtalk(void)
?ProgramDiamondXtalk@CXtalkHw@@QAEXXZ:
		sub	esp, 0Ch
		mov	ax, word ptr ds:?sDiamondKRightXt@@3FB+2
		push	esi
		mov	esi, ecx
		push	offset ?asDiamondCoefsLeftEq@@3PAY04FA ; short (* asDiamondCoefsLeftEq)[5]
		mov	cx, word ptr ds:?sDiamondKLeftEq@@3FB ;	short const sDiamondKLeftEq
		push	eax
		push	ecx
		mov	ecx, esi
		call	?SetLeftEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftEQ(short,short,short (* const)[5])

		mov	dx, word ptr ds:?sDiamondShiftRightEq@@3FB ; short const sDiamondShiftRightEq
		mov	ax, word ptr ds:?sDiamondKRightEq@@3FB ; short const sDiamondKRightEq
		push	offset ?asDiamondCoefsRightEq@@3PAY04FA	; short	(* asDiamondCoefsRightEq)[5]
		push	edx
		push	eax
		mov	ecx, esi
		call	?SetRightEQ@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightEQ(short,short,short (* const)[5])

		mov	cx, word ptr ds:?sDiamondShiftLeftXt@@3FB ; short const	sDiamondShiftLeftXt
		mov	dx, word ptr ds:?sDiamondKLeftXt@@3FB ;	short const sDiamondKLeftXt
		push	offset ?asDiamondCoefsLeftXt@@3PAY04FA ; short (* asDiamondCoefsLeftXt)[5]
		push	ecx
		push	edx
		mov	ecx, esi
		call	?SetLeftXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetLeftXT(short,short,short (* const)[5])

		mov	ax, word ptr ds:?sDiamondShiftRightXt@@3FB ; short const sDiamondShiftRightXt
		mov	cx, word ptr ds:?sDiamondKRightXt@@3FB ; short const sDiamondKRightXt
		push	offset ?asDiamondCoefsRightXt@@3PAY04FA	; short	(* asDiamondCoefsRightXt)[5]
		push	eax
		push	ecx
		mov	ecx, esi
		call	?SetRightXT@CXtalkHw@@QAEXFFQAY04F@Z ; CXtalkHw::SetRightXT(short,short,short (* const)[5])

		mov	dx, word ptr ds:?wDiamondRightDelay@@3GB ; ushort const	wDiamondRightDelay
		mov	ax, word ptr ds:?wDiamondLeftDelay@@3GB	; ushort const wDiamondLeftDelay
		mov	[esp+8], dx
		mov	[esp+0Ch], ax
		mov	dword ptr [esp+4], 0
		mov	ecx, [esp+4]
		and	ecx, 1FFFFFFFh
		or	ecx, 0A0000000h
		mov	[esp+4], ecx
		mov	edx, [esp+8]
		and	edx, 1Fh
		shl	edx, 8
		mov	eax, [esp+4]
		and	ah, 0E0h
		or	edx, eax
		mov	[esp+4], edx
		mov	ecx, [esp+0Ch]
		and	ecx, 1Fh
		shl	ecx, 0Dh
		mov	edx, [esp+4]
		and	edx, 0FFFC1FFFh
		or	ecx, edx
		mov	[esp+4], ecx
		mov	eax, [esp+4]
		mov	ecx, [esi]
		push	eax
		push	offset loc_24660
		call	?Write@CAsp4HwIO@@QAEXKK@Z ; CAsp4HwIO::Write(ulong,ulong)

		pop	esi
		add	esp, 0Ch
		retn
