/***************************************************************************
 *            au88x0_a3d.c
 *
 *  Fri Jul 18 14:16:22 2003
 *  Copyright  2003  mjander
 *  mjander@users.sourceforge.net
 *
 * A3D. You may think i'm crazy, but this may work someday. Who knows...
 ****************************************************************************/



/* CA3dSourceHw */
void Asp4A3DTopology__MakeConnections(vortex_t * vortex) {
	if (this_34 == 1) {		/* Source, is mixed with something else. */
		/* Connect 0x50 to MIXIN */
		Asp4Topology_Route((int) 1, (uchar) this_0c->this_0c, 
			(uchar) this_08->this_04, (uchar) this_10 + 0x50, (uchar) this_14+0x50);
		/* Connect MIXIN's this_10 and this_14 to MIXOUT this_18 */
		(CAsp4Mix)this_18_EnableInput(int this_10);
		(CAsp4Mix)this_18_EnableInput(int this_14);
		/* Connect MIXOUT this_18 to SRCIN this_0c */
		Asp4Topology_Route((int) 1, (uchar) this_0c, 
			(uchar) this_18->this_08 + 0x30, (uchar) this_0c + 0x40);
		/* Connect SRCOUT this_0c to A3DIN this_20 */
		Asp4Topology_Route((int) 1, (uchar) 0x11, 
			(uchar) this_0c->this0c + 0x20, (uchar) this_20 + 0x70);
	} else {		/* Source, directly piped through SRC (doppler) into A3D. */
		if (this_08) { /* Route ADB DMA to A3D */
			/* Connect this_08 to SRCIN this_0c */
			Asp4Topology_Route((int) 1, (uchar) this_0c, 
				(uchar) this_08->this_04, (uchar) this_0c + 0x40);
			/* Connect SRCOUT this_0c to A3DIN this_20 */
			Asp4Topology_Route((int) 1, (uchar) 0x11, 
				(uchar) this_0c->this0c + 0x20, (uchar) this_20 + 0x70);		
		} else {	/* Looks like route to DSP coprocessor ? */
			/* Connect WT to A3DIN this_20 */
			Asp4Topology_Route((int) 1, (uchar) 0x11, 
				//(uchar) ((((this_24->this04 <= 0x20)?0x1:0)-1)&0xFFFFFFC0)+0x80+(this_24->this04&0x1f),
				//(uchar) (((this_24->this04 > 0x20)?0:0xFFFFFFC0)+0x80+(this_24->this04&0x1f),
				//(uchar) ((((this_24->this04 < 0x20)?0x1:0)-1)&0xFFFFFFC0)+0x80+(this_24->this04&0x1f),
				(uchar) ((this_24->this04 > 0x20)?0x80:0x40)+(this_24->this04 & 0x1f),
				(uchar) this_20 + 0x70);		
			/* Search for mixers referred by 0x8f, 0x90 and return in this_38, this_3c */
			
			/* Connect WT to A3DIN this_2c */
			Asp4Topology_Route((int) 1, (uchar) 0x11, 
				(uchar) ((this_24->this04 > 0x20)?0x80:0x40)+(this_24->this04 & 0x1f),
				(uchar) this_2c + 0x70);
			/* Enable output to mixers this_0x38 and this_0x3c */
			(CAsp4Mix)this_38_EnableInput(int this_2c);
			(CAsp4Mix)this_3c_EnableInput(int this_2c);	
			/* Set mixer volumes */
		}
	}
}

void Asp4A3DTopology__MakeDisconnections(void) {
	char mix0, mix1;
	
	if (this_28 == 0)
		return;
	
	if (this_34 == 1) {
		
		
	} else {
		
		
	}
}



void Asp4Topology__AllocA3D(class CResource *arg_0, (int) arg_4) {
	/* Fail path has been left out for now. */
	Asp4A3DTopology_Asp4A3DTopology((CResource *)arg_0, (Asp4Topology *)this_00);
	Asp4A3DTopology_Create((int) arg_4, (SPEAKER_OUTPUTMODE) this_15C);
	if (!this_84->this_0c)
		CList<TopologyObj *>_NewBlock(void);
	/* Looks like initialization of a linked list */
	this_84->this_0c = *this_84->this_0c;
	*(this_84->this_0c) = 0;
	*(this_84->this_10) = 0;
	*this->84->this_08++;
	*this->84->this_04 = Asp4A3DTopology;
	
	if ()
	 //line 68242
	
}
/* A3D HwSOurce stuff. */

void CA3dSourceHw_CA3dSourceHw(CAsp4HwIO *hwio, int a,int b) {
	CA3dSourceHw->this00 = hwio;
	CA3dSourceHw->this04 = a;
	CA3dSourceHw->this08 = b;
}

void CA3dSourceHw_Initialize(int a, int b) {
	CA3dSourceHw->this04 = a; /* source */
	CA3dSourceHw->this08 = b; /* slice */
	CA3dSourceHw_ZeroState(void);
}


void CA3dSourceHw_SetTimeConsts(short a, short b, short c, short d) {
	hwwrite(vortex->mmio, addr(A3D_A_HrtfTrackTC, this04, this08),  a);
	hwwrite(vortex->mmio, addr(A3D_A_ITDTrackTC, this04, this08),  b);
	hwwrite(vortex->mmio, addr(A3D_A_GainTrackTC, this04, this08),  c);
	hwwrite(vortex->mmio, addr(A3D_A_CoeffTrackTC, this04, this08),  d);
}

void CA3dSourceHw_GetTimeConsts(short a, short b, short c, short d) {
	// stub!
}

/* Atmospheric absorbtion. */

void CA3dSourceHw_SetAtmosTarget(vortex_t *vortex, char a3d, short a,short b,short c,short d,short e) {
	//hwwrite(vortex->mmio, addr(0x190Ec, this04, this08), (e << 0x10) | d);
	hwwrite(vortex->mmio,a3d_addr(a3d_ss(a3d),A3D_B_A21Target),(e << 0x10) | d);
	//hwwrite(vortex->mmio, addr(0x190F4, this04, this08), (b << 0x10) | a);
	hwwrite(vortex->mmio,a3d_addr(a3d_ss(a3d),A3D_B_B10Target),(b << 0x10) | a);
	//hwwrite(vortex->mmio, addr(0x190FC, this04, this08), c);
	hwwrite(vortex->mmio,a3d_addr(a3d_ss(a3d),A3D_B_B2Target), c);
}

void CA3dSourceHw_GetAtmosTarget(short *a,short *b,short *c,short *d,short *e) {
}

void CA3dSourceHw_SetAtmosCurrent(char a3d, short a,short b,short c,short d,short e) {
	
	hwwrite(vortex->mmio, addr(A3D_B_A12Current, this04, this08), (e << 0x10) | d);
	hwwrite(vortex->mmio, addr(A3D_B_B01Current, this04, this08), (b << 0x10) | a);
	hwwrite(vortex->mmio, addr(A3D_B_B2Current, this04, this08), c);
}

void CA3dSourceHw_GetAtmosCurrent(short *a,short *b,short *c,short *d,short *e) {
	*d = hwread(vortex->mmio, addr(A3D_A_A12Current, this04, this08));
	*e = hwread(vortex->mmio, addr(A3D_B_A12Current, this04, this08));
	*b = hwread(vortex->mmio, addr(A3D_A_B01Current, this04, this08));
	*a = hwread(vortex->mmio, addr(A3D_B_B01Current, this04, this08));
	*c = hwread(vortex->mmio, addr(A3D_A_B2Current, this04, this08));
}

void CA3dSourceHw_SetAtmosState(short a,short b,short c,short d) {
	hwwrite(vortex->mmio, a3d_addr(A3D_A_x1, this04, this08), a);
	hwwrite(vortex->mmio, a3d_addr(A3D_A_x2, this04, this08), b);
	hwwrite(vortex->mmio, a3d_addr(A3D_A_y1, this04, this08), c);
	hwwrite(vortex->mmio, a3d_addr(A3D_A_y2, this04, this08), d);
}

void CA3dSourceHw_GetAtmosState(short a,short b,short c,short d) {
	
}


/* HRTF */

void CA3dSourceHw_SetHrtfTarget(short const *a, short const	*b) {
	int i;
	
	for (i=0; i<0x38; i++)
		hwwrite(vortex->mmio, a3d_addr(A3D_B_HrtfTarget + (i<<2), this04, this08), (b[i]<<0x10) | a[i]);
}

void CA3dSourceHw_GetHrtfTarget(short const *a, short const	*b) {
}

void CA3dSourceHw_SetHrtfCurrent(short const *a, short const *b) {
	int i;
	
	for (i=0; i<0x38; i++)
		hwwrite(vortex->mmio, a3d_addr(A3D_B_HrtfCurrent + (i<<2), this04, this08), (b[i]<<0x10) | a[i]);
}

void CA3dSourceHw_GetHrtfCurrent(short const *a, short const *b) {
	int i;
	// FIXME: verify this!
	for (i=0; i<0x38; i++)
		a[i] = hwread(vortex->mmio, a3d_addr(A3D_A_HrtfCurrent + (i<<2), this04, this08));
	for (i=0; i<0x38; i++)
		b[i] = hwread(vortex->mmio, a3d_addr(A3D_B_HrtfCurrent + (i<<2), this04, this08));	
}

void CA3dSourceHw_SetHrtfState(short const *a, short const *b) {
	int i;
	
	for (i=0; i<0x38; i++)
		hwwrite(vortex->mmio, a3d_addr(A3D_B_HrtfDelayLine + (i<<2), this04, this08), (b[i]<<0x10) | a[i]);	
}

void CA3dSourceHw_GetHrtfState(short const *a, short const *b) {
	int i;
	// FIXME: verify this!
	for (i=0; i<0x38; i++)
		a[i] = hwread(vortex->mmio, a3d_addr(A3D_A_HrtfDelayLine + (i<<2), this04, this08));
	for (i=0; i<0x38; i++)
		b[i] = hwread(vortex->mmio, a3d_addr(A3D_B_HrtfDelayLine + (i<<2), this04, this08));	
}

void CA3dSourceHw_GetHrtfOutput(short *left, short *right) {
	*left = hwread(vortex->mmio, a3d_addr(A3D_A_HrtfOutL, this04, this08));
	*right = hwread(vortex->mmio, a3d_addr(A3D_A_HrtfOutR, this04, this08));
}

void CA3dSourceHw_SetHrtfOutput(short left,short right) {
	hwwrite(vortex->mmio, a3d_addr(A3D_A_HrtfOutL, this04, this08), left);
	hwwrite(vortex->mmio, a3d_addr(A3D_A_HrtfOutR, this04, this08), right);
}

/* Interaural Time Difference. 
 * "The other main clue that humans use to locate sounds, is called 
 * Interaural Time Difference (ITD). The differences in distance from 
 * the sound source to a listeners ears means  that the sound will 
 * reach one ear slightly before the other....", found somewhere with google.*/
void CA3dSourceHw_SetItdTarget(short litd,short ritd) {
	if (litd < 0)
		litd = 0;
	if (litd > 0x57FF)
		litd = 0x57FF;
	if (ritd < 0)
		ritd = 0;
	if (ritd > 0x57FF)
		ritd = 0x57FF;
	hwwrite(vortex->mmio, a3d_addr(A3D_B_ITDTarget, this04, this08), (ritd<<0x10)|litd);
	//hwwrite(vortex->mmio, addr(0x191DF+5, this04, this08), (ritd<<0x10)|litd);
}

void CA3dSourceHw_GetItdTarget(short *litd, short *ritd) {
	*ritd = hwread(vortex->mmio, a3d_addr(A3D_A_ITDTarget, this04, this08));
	*litd = hwread(vortex->mmio, a3d_addr(A3D_B_ITDTarget, this04, this08));
}

void CA3dSourceHw_SetItdCurrent(short litd, short ritd) {
		litd = 0;
	if (litd > 0x57FF)
		litd = 0x57FF;
	if (ritd < 0)
		ritd = 0;
	if (ritd > 0x57FF)
		ritd = 0x57FF;
	hwwrite(vortex->mmio, a3d_addr(A3D_B_ITDCurrent, this04, this08), (ritd<<0x10)|litd);
	//hwwrite(vortex->mmio, addr(0x191DF+1, this04, this08), (ritd<<0x10)|litd);
}

void CA3dSourceHw_GetItdCurrent(short *litd,short *ritd) {
	*ritd = hwread(vortex->mmio, a3d_addr(A3D_A_ITDCurrent, this04, this08));
	*litd = hwread(vortex->mmio, a3d_addr(A3D_B_ITDCurrent, this04, this08));
}

void CA3dSourceHw_SetItdDline(short const	*dline) {
	int i;
	/* 45 != 40 -> Check this ! */
	for (i=0; i<0x28; i++)
		hwwrite(vortex->mmio, a3d_addr(A3D_A_ITDDelayLine + (i<<2), this04, this08), dline[i])
}

void CA3dSourceHw_GetItdDline(short *dline) {
	int i;
	
	for (i=0; i<0x28; i++)
		dline[i] = hwwrite(vortex->mmio, a3d_addr(A3D_A_ITDDelayLine + (i<<2), this04, this08));	
}

/* This is may be used for IID Interaural Intensity Difference. */

void CA3dSourceHw_SetGainTarget(short a,short b) {
	hwwrite(vortex->mmio, addr(A3D_B_GainTarget, this04, this08), (b<<0x10)|a);
}

void CA3dSourceHw_GetGainTarget(short *,short *) {
	*b = hwread(vortex->mmio, addr(A3D_A_GainTarget, this04, this08));
	*a = hwread(vortex->mmio, addr(A3D_B_GainTarget, this04, this08));
}

void CA3dSourceHw_SetGainCurrent(short a,short b) {
	hwwrite(vortex->mmio, addr(A3D_B_GainCurrent, this04, this08), (b<<0x10)|a);
	//hwwrite(vortex->mmio, addr(0x190DC+4, this04, this08), (b<<0x10)|a);
}

void CA3dSourceHw_GetGainCurrent(short *a,short *b) {
	*b = hwread(vortex->mmio, addr(A3D_A_GainCurrent, this04, this08));
	*a = hwread(vortex->mmio, addr(A3D_B_GainCurrent, this04, this08));
}

/* Generic A3D stuff */

void CA3dSourceHw_SetA3DSampleRate(int sr) {
	int esp0 = 0;
	esp0 = (((esp0 & 0x7fffffff)|0xB8000000)&0x7) | ((sr&0x1f)<<3);
	hwwrite(vortex->mmio, A3D_SLICE_Control + (this08<<0xd), esp0);
	//hwwrite(vortex->mmio, 0x19C38 + (this08<<0xd), esp0);
}

void CA3dSourceHw_GetA3DSampleRate(int *sr) {
	*sr = ((hwread(vortex->mmio, A3D_SLICE_Control + (this08<<0xd))>>3)&0x1f);
	//*sr = ((hwread(vortex->mmio, 0x19C38 + (this08<<0xd))>>3)&0x1f);
}

void CA3dSourceHw_EnableA3D(void) {
	hwwrite(vortex->mmio, A3D_SLICE_Control + (this08<<0xd), 0xF0000001);
	//hwwrite(vortex->mmio, 0x19C38 + (this08<<0xd), 0xF0000001);
}

void CA3dSourceHw_DisableA3D(void) {
	hwwrite(vortex->mmio, A3D_SLICE_Control + (this08<<0xd), 0xF0000000);
}

void CA3dSourceHw_SetA3DControlReg(unsigned long ctrl) {
	hwwrite(vortex->mmio, A3D_SLICE_Control + (this08<<0xd), ctrl);
}

void CA3dSourceHw_GetA3DControlReg(unsigned long *ctrl) {
	*ctrl = hwread(vortex->mmio, A3D_SLICE_Control + (this08<<0xd));
}

void CA3dSourceHw_SetA3DPointerReg(unsigned long ptr) {
	hwwrite(vortex->mmio, A3D_SLICE_Pointers + (this08<<0xd), ctrl);
}

void CA3dSourceHw_GetA3DPointerReg(unsigned long *ptr) {
	*ptr = hwread(vortex->mmio, A3D_SLICE_Pointers + (this08<<0xd));
}

void CA3dSourceHw_ZeroSliceIO(void) {
	int i;
	
	for (i=0; i<8; i++)
		hwwrite(vortex->mmio, A3D_SLICE_VDBDest + (((this08<<0xb)+i)*4), 0);
	for (i=0; i<4; i++)
		hwwrite(vortex->mmio, A3D_SLICE_VDBSource + (((this08<<0xb)+i)*4), 0);	
}

void CA3dSourceHw_ZeroState(void) {
	int i;
	
	CA3dSourceHw_SetAtmosState(0,0,0,0);
	CA3dSourceHw_SetHrtfState(A3dHrirZeros, A3dHrirZeros);
	CA3dSourceHw_SetItdDline(A3dItdDlineZeros, A3dItdDlineZeros);
	CA3dSourceHw_SetHrtfOutput(0, 0);
	CA3dSourceHw_SetTimeConsts(0,0,0,0);
	CA3dSourceHw_SetAtmosCurrent(0,0,0,0,0);
	CA3dSourceHw_SetAtmosTarget(0,0,0,0,0);
	CA3dSourceHw_SetItdCurrent(0,0);
	CA3dSourceHw_SetItdTarget(0,0);
	CA3dSourceHw_SetGainCurrent(0,0);
	/* The person who originally wrote this surely was smoking crack ...
	/* (or his/her compiler) */
	CA3dIO_WriteReg(A3D_B_GainTarget + (this08<<0xd) + (this04*5*9*2 - this04)*8,0,0);
	
	CA3dSourceHw_SetHrtfCurrent(A3dHrirZeros, A3dHrirZeros);
	CA3dSourceHw_SetHrtfTarget(A3dHrirZeros, A3dHrirZeros)
}

void CA3dSourceHw_ZeroStateA3D(void) {
	int i, ii, var, var2;
	
	CA3dSourceHw_SetA3DControlReg(0);
	CA3dSourceHw_SetA3DPointerReg(0);
	var = this08;
	var2 = this04; // ??
	for (ii=0; ii<4; ii++) {
		this08 = ii;
		
		CA3dSourceHw_ZeroSliceIO(void);
		CA3dSourceHw_ZeroState(void);	
	}
	this04 = var2;
	this08 = var;
}

/* Program A3D block as pass through */
void CA3dSourceHw_ProgramPipe(void) {
	CA3dSourceHw_SetTimeConsts(0,0,0,0);
	CA3dSourceHw_SetAtmosCurrent(0, 0x4000, 0,0,0);
	CA3dSourceHw_SetAtmosTarget(0x4000,0,0,0,0);
	CA3dSourceHw_SetItdCurrent(0,0);
	CA3dSourceHw_SetItdTarget(0,0);
	CA3dSourceHw_SetGainCurrent(0x7fff,0x7fff);
	CA3dSourceHw_SetGainTarget(0x7fff,0x7fff);
	CA3dSourceHw_SetHrtfCurrent(A3dHrirImpulse, A3dHrirImpulse);
	CA3dSourceHw_SetHrtfTarget(A3dHrirImpulse, A3dHrirImpulse);
}
/* VDB = Vortex audio Dataflow Bus */
void CA3dSourceHw_ClearVDBData(unsigned long a) {
	hwwrite(vortex->mmio, 0x19c00 + (((a>>2)*255*4)+a)*8, 0);
	hwwrite(vortex->mmio, 0x19c04 + (((a>>2)*255*4)+a)*8, 0);
}
/* CA3dIO this func seems to be inlined all over this place. */

void CA3dIO_WriteReg(unsigned long addr, short a, short b) {
	hwwrite(vortex->mmio, addr, (a<<0x10)|b);
}

/* CHrtf */
void CHrtf_CHrtf(void) {
	this_00 = 0;
	this_04 = 0;
	this_08 = 0;
}
void CHrtf_Initialize(int arg_0 ,int arg_4 ,short *arg_8) {
	this_04 = arg_0;
	this_00 = arg_4;
	this_08 = *arg_8;
}
void CHrtf_InterpolateHrtf(short *arg_0, short *arg_4, short *arg_8) {
	// No thanks for now :D
}
/* CVort3dRend */

void CVort3DRend_CVort3DRend(class CAsp4Core *core, class CAsp4HwIO *hwio) {
	this00 = core;
	this04 = hwio;
	this08 = 0;
}

void CVort3DRend_~CVort3DRend(void) {
	if (this08)
		operator delete(this08);
}

int CVort3DRend_Initialize(unsigned short a) {
	if (this00 == 0)
		return -1;
	this14 = a;
	CXtalkHw = operator new(4);
	CXtalkHw_CXtalkHw(this04);

	CXtalkHw_SetGains(XtalkGainsAllChan);
	if (this14) {
		if (this08==0xffff) {
			/* Speaker type 1 ? */
			CXtalkHw_ProgramXtalkNarrow(void);
		} else{
			/* Speaker type 2 ? */
			CXtalkHw_ProgramXtalkWide(void)
		}
	} else {
		/* Headphones ? */
		CXtalkHw_ProgramPipe(void);
	}
	CXtalkHw_SetSampleRate(0x11);
	CXtalkHw_Enable(void);
}

int CVort3DRend_SetGlobalControl(struct _XTALKctrl *xtctrl) {
	if (xtctrl==0)
		return 0;
	
	this0c->this04 = xtctrl->this04;
	this0c->this08 = xtctrl->this08;
	this0c->this0c = xtctrl->this0c;
	
	this0c = xtctrl->this00;
	CXtalkHw = this08; 
	if (this14) {
		if (this08==0xffff)
			CXtalkHw_ProgramXtalkNarrow(void);
		else
			CXtalkHw_ProgramXtalkWide(void)
	} else {
		CXtalkHw_ProgramPipe(void);
	}
}

int  CVort3DRend_GetGlobalControl(struct _XTALKctrl *xtctrl) {
}
int CVort3DRend_AddBuffer(class CVort3dWave *a) {
	return 0;
}
int CVort3DRend_RemoveBuffer(class CVort3dWave *a) {
	return 0;
}
/* CVort3dWave */

void CVort3dWave_CVort3dWave(class CAsp4Core *,class CAsp4HwIO	*,class	CHrtfMgr *) {
	
}
//174743
void CVort3dWave_Initialize(struct _ASPWAVEFORMAT * arg_0, void (__stdcall *)(class CAuWave *,char *,unsigned long,int,unsigned long,unsigned long),unsigned long arg_4 ,void *arg_c) {
	a3dsource_t a3d;
	CWave_Initialize(_ASPWAVEFORMAT *arg_0 ,ASPDIRECTION 0,void (*)(CAuWave *,char *,ulong ,int,ulong,ulong) arg_4,void *arg_c, ulong 1);
	
	this_320 = 0;
	this_324 = 0;
	this_334 = (short)0xffff;
	this_338 = (short)0x8000;
	this_328 = 0;
	this_77c = 0;
	this_790 = 0;
	this_794 = 0;
	this_7a4 = 0;
	this_7c8 = 0; /* struct ? */
	this_79c = 0;
	this_7a0 = 0;
	this_7b4 = 0;
	this_7c0 = 0;
	this_7b0 = 0;
	this_7bc = 0;
	this_788 = 0;
	this_7cc = 0;
		
	if ((a3d = CAdbTopology_GetA3DSource(void)) < 0) {
		(CAsp4Core)this_318_GetProperty((COREPROPERTY) 4, void *arg_c, (ulong) 4);
		if (arg_c == 1)
			return 8007000E;
	} else {
		if (this_340 == 0) {
			operator new((uint) 0xc, (_POOL_TYPE) 0, (ulong) 44334143);
		
		}
	}
}
	
void CVort3DWave_SetLRGains(void) {
	
	
}

int  CVort3dWave_Set3dParms(unsigned long offset, unsigned long arg4, void * arg8) {
	
	if (offset)
		return 80070057;
	if (arg4 == 0xf6) {
		CVort3dWave_Anzio3dToSuperCtrl((Anzio3d *) arg8, (A3DCTRL_SRC_SUPER *) this_370);
		CVort3dWave_Set3dParms((A3DCTRL_SRC_SUPER *) this_370);
		return 0;
	}
	if (arg4 == 0x40) {
		CVort3dWave_Set3dParms((A3DCTRL_SRC_SUPER *) arg8)
	}
}

int  CVort3dWave_Set3dParms(struct A3DCTRL_SRC_SUPER *) {
	int var14;
	struct var0 {
		int a;
		short b;
		char c;
	};

	CAsp4Core = this_318;
	CAsp4Core_GetProperty((COREPROPERTY) 4, (void *) &var14, (ulong) 4);
	CAsp4Core_GetProperty((COREPROPERTY) 1, (void *) &var0+0x10, (ulong) 0x10);
	if ((var0.b != this_354)||(var14 != this_350)) {
		this_354 = var0.b;
		this_350 = var14;
		CHrtfMgr = this_344;
		if (var14 == 1) {
			if (var0.b)
				CHrtfMgr_Initialize((ulong) 0xBB80, (ulong) 0x3a, (ulong) 0x102)
			else
				CHrtfMgr_Initialize((ulong) 0xBB80, (ulong) 2, (ulong) 0x101);
		} else
			CHrtfMgr_Initialize((ulong) 0xBB80, (ulong) 0x38, (ulong) 0);
	}
	if (var14 == 1) {
		if (var0.b == 0)
			CVort3dWave_RenderQuadPan((A3DCTRL_SRC_SUPER *) arg0);
		else
			CVort3dWave_RenderSuperQuad((A3DCTRL_SRC_SUPER *) arg0);
		return 0;
	}
	eax = CAdbTopology_GetA3DSource(void);
	if (eax >= 0) 
		CVort3dWave_Render3d((A3DCTRL_SRC_SUPER *) arg0);
	else
		CVort3dWave_Render2d((A3DCTRL_SRC_SUPER *) arg0);
	return 0;
}

void CVort3dWave_Render2d(struct A3DCTRL_SRC_SUPER *) {
	
	CVort3dWave_Calc2d(A3DCTRL_EAR *,A3DCTRL_EAR	*,float,ulong *,_ASPVOLUME *);
	
	CVort3dWave_SetLRGains(void);
	CAdbTopology_SetFilter(ulong);
	
}
void CVort3dWave_Render3d(struct A3DCTRL_SRC_SUPER *) {
	
	CA3dSourceHw_SetAtmosTarget(short,short,short,short,short);
	CA3dSourceHw_SetAtmosCurrent(short,short,short,short,short);
	CVort3dWave_SetLRGains(void);
	CA3dSourceHw_SetHrtfTarget(short const *,short const *);
	CA3dSourceHw_SetHrtfCurrent(short const *,short const *)
	CA3dSourceHw_SetItdTarget(short,short);
}

void CVort3dWave_RenderQuadPan(struct A3DCTRL_SRC_SUPER *) {
	
	
}

void CAdbTopology_SetFilter(unsigned long a) {
	int eax;
	
	if (this_1E0 == 0)
		return;  // "CAdbTopology_SetFilter - m_pWtDma not available\n"
	if (a) {
		if (a & 0xFFFF0000)
			eax = 0xcf;
		else {
			a <<= 0x10;
			eax = 0xc;
			while (((a & 0x80000000) == 0)&&(eax > 0)) {
				a <<= 1;
				eax--;
			}
			if (eax) 
				a << 1;
			eax <<= 4;
			a >>= 0x1c;
			eax |= a;
		}
	} else
		eax = 0;
	this_1E4 = (this_1E4 & 0xFFFFFF) | (eax << 0x18);
	this_1E8 = this_1E4 | 1;
	AuWt_WriteReg(0x204 + (this_1DC << 4), this_1E8);
	AuWt_WriteReg(0x200 + (this_1DC << 4), this_1E4);
}

void AuWt_WriteReg(unsigned long addr, unsigned long data) {
	hwwrite(vortex->mmio, (this_04 << 0xf) + addr, data);
}

int  AuWt_ReadReg(unsigned long addr) {
	return hwread(vortex->mmio, (this_04 << 0xf) + addr);
}
